## gofigure2 0.8.1

=== CMakeLists.txt ===
PROJECT( GOFIGURE2 )

# CMake >= 2.8.2 MUST be installed (which is requiered by ITK)
CMAKE_MINIMUM_REQUIRED( VERSION 2.8.2 )

IF( COMMAND CMAKE_POLICY )
  CMAKE_POLICY( VERSION 2.6 )
  CMAKE_POLICY( SET CMP0005 OLD )
  CMAKE_POLICY( SET CMP0003 NEW )
ENDIF(COMMAND CMAKE_POLICY)

# When making one release: update GOFIGURE2_*_VERSION,
# GOFIGURE2_WC_REVISION and the date of the release
SET( GOFIGURE2_MAJOR_VERSION "0" )
SET( GOFIGURE2_MINOR_VERSION "8" )
SET( GOFIGURE2_WC_REVISION "1" )

SET( DATE "03/29/2011" )

SET( GOFIGURE2_VERSION
  "${GOFIGURE2_MAJOR_VERSION}.${GOFIGURE2_MINOR_VERSION}.${GOFIGURE2_WC_REVISION}" )

SET( GOFIGURE2_LIB_VERSION
  "${GOFIGURE2_MAJOR_VERSION}.${GOFIGURE2_MINOR_VERSION}" )

MESSAGE( STATUS "GoFigure2 version ${GOFIGURE2_VERSION}" )

# On Visual Studio 8 MS deprecated C. This removes all 1.276E1265 security
# warnings. Copied from ITK CMakeLists.
IF( WIN32 )
  IF( NOT BORLAND )
    IF( NOT CYGWIN )
      IF( NOT MINGW )
          ADD_DEFINITIONS(
            -D_CRT_FAR_MAPPINGS_NO_DEPRECATE
            -D_CRT_IS_WCTYPE_NO_DEPRECATE
            -D_CRT_MANAGED_FP_NO_DEPRECATE
            -D_CRT_NONSTDC_NO_DEPRECATE
            -D_CRT_SECURE_NO_DEPRECATE
            -D_CRT_SECURE_NO_DEPRECATE_GLOBALS
            -D_CRT_SETERRORMODE_BEEP_SLEEP_NO_DEPRECATE
            -D_CRT_TIME_FUNCTIONS_NO_DEPRECATE
            -D_CRT_VCCLRIT_NO_DEPRECATE
            -D_SCL_SECURE_NO_DEPRECATE
            )
      ENDIF( NOT MINGW )
    ENDIF( NOT CYGWIN )
  ENDIF( NOT BORLAND )
ENDIF( WIN32 )

#-----------------------------------------------------------------------
# Export and Install configuration
#
# GOFIGURE2_INSTALL_BUNDLE_DIR       - bundle dir
# GOFIGURE2_INSTALL_HEADER_DIR       - include dir (headers)
# GOFIGURE2_INSTALL_BIN_DIR          - binary dir (executables)
# GOFIGURE2_INSTALL_LIB_DIR          - library dir (libs)
# GOFIGURE2_INSTALL_DOC_DIR          - documentation dir
# GOFIGURE2_INSTALL_LICENSE_DIR      - licenses dir
#-----------------------------------------------------------------------
IF( NOT GOFIGURE2_INSTALL_BUNDLE_DIR )
  SET( GOFIGURE2_INSTALL_BUNDLE_DIR "." )
ENDIF( NOT GOFIGURE2_INSTALL_BUNDLE_DIR )

IF( NOT GOFIGURE2_INSTALL_HEADER_DIR )
  SET( GOFIGURE2_INSTALL_HEADER_DIR "include/gofigure2" )
ENDIF( NOT GOFIGURE2_INSTALL_HEADER_DIR )

IF( NOT GOFIGURE2_INSTALL_BIN_DIR )
  SET( GOFIGURE2_INSTALL_BIN_DIR "bin" )
ENDIF( NOT GOFIGURE2_INSTALL_BIN_DIR )

IF( NOT GOFIGURE2_INSTALL_LIB_DIR )
  SET( GOFIGURE2_INSTALL_LIB_DIR "lib/gofigure2" )
ENDIF( NOT GOFIGURE2_INSTALL_LIB_DIR )

IF( NOT GOFIGURE2_INSTALL_DOC_DIR )
  SET( GOFIGURE2_INSTALL_DOC_DIR "share/doc/gofigure2" )
ENDIF( NOT GOFIGURE2_INSTALL_DOC_DIR )

IF( NOT GOFIGURE2_INSTALL_LICENSE_DIR )
  SET( GOFIGURE2_INSTALL_LICENSE_DIR "share/doc/gofigure2/Licenses" )
ENDIF( NOT GOFIGURE2_INSTALL_LICENSE_DIR )

#---------------------------------------------------------------------------
# Define CMAKE_whatever_OUTPUT_DIRECTORY
#---------------------------------------------------------------------------
# all target executables will be
# in ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
SET( CMAKE_RUNTIME_OUTPUT_DIRECTORY
  ${GOFIGURE2_BINARY_DIR}/bin
)

# all target static libraries will be in ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}
SET( CMAKE_ARCHIVE_OUTPUT_DIRECTORY
  ${GOFIGURE2_BINARY_DIR}/lib
)

# all shared libraries will be in ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
# Note that modules (plugins) are considered as shared libraries
SET( CMAKE_LIBRARY_OUTPUT_DIRECTORY
#  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/plugins
   ${GOFIGURE2_BINARY_DIR}/lib
)
SET( GOFIGURE2_LIBRARY_DIRS ${GOFIGURE2_BINARY_DIR}/lib )

#---------------------------------------------------------------------------
# Define TESTING_DATA_PATH
#---------------------------------------------------------------------------
SET( TESTING_DATA_PATH
  ${GOFIGURE2_SOURCE_DIR}/Testing/Data
  CACHE PATH "Directory which contains data for testing."
)

#---------------------------------------------------------------------------
# Handle Documentation
#---------------------------------------------------------------------------
OPTION( BUILD_DOCUMENTATION "Build Doxygen Documentation" OFF )

#---------------------------------------------------------------------------
IF( BUILD_DOCUMENTATION )
  FIND_PACKAGE( Doxygen )
  IF( DOXYGEN_FOUND )
    IF( DOXYGEN_DOT_FOUND )

      OPTION( LINK_EXTERNAL_DOC
        "Should the doc be linked with external sources (VTK, ITK...)?"
        OFF
      )

      ADD_SUBDIRECTORY( Documentation )

    ELSE( DOXYGEN_DOT_FOUND )
      MESSAGE( SEND_ERROR
        "Warning: Dot (from GraphViz) not found - Documentation will not ce generated"
      )
    ENDIF( DOXYGEN_DOT_FOUND )
  ELSE( DOXYGEN_FOUND )
    MESSAGE( SEND_ERROR
      "Warning: Doxygen not found - Documentation will not be created"
    )
  ENDIF( DOXYGEN_FOUND )
ENDIF( BUILD_DOCUMENTATION )

#---------------------------------------------------------------------------
# Main GoFigure Settings
#---------------------------------------------------------------------------

SET( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
  "${GOFIGURE2_SOURCE_DIR}/CMake/"
)

IF( UNIX )
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
ENDIF( UNIX )

OPTION( BUILD_COMPARETOOL "Build image comparison tool" OFF )

# Everything depends on VTK first
# that way we can get Qt info from VTK
#### VTK ####
FIND_PACKAGE( VTK REQUIRED )
IF( VTK_FOUND )

  # Check the version of VTK
  # GoFigure2 requires vtk >= 5.6
  IF( ( ${VTK_MAJOR_VERSION} LESS 5 ) OR ( ${VTK_MINOR_VERSION} LESS 6 ) )
    MESSAGE( SEND_ERROR
      "GoFigure2 requires VTK 5.6 (your version of VTK is ${VTK_VERSION})" )
  ENDIF( ( ${VTK_MAJOR_VERSION} LESS 5 ) OR ( ${VTK_MINOR_VERSION} LESS 6 ) )

  SET( VTK_MAJOR_VERSION ${VTK_MAJOR_VERSION}
    CACHE STRING INTERNAL )
  SET( VTK_MINOR_VERSION ${VTK_MINOR_VERSION}
    CACHE STRING INTERNAL )

  MARK_AS_ADVANCED( VTK_MAJOR_VERSION VTK_MINOR_VERSION )

  # Check if version of VTK is > 5.6
  # Requiered to now if we can use setBitRate() and setBitRateTolerance
  # in the vtkFFMPEGWriter
  IF( ( ${VTK_MAJOR_VERSION} EQUAL 5 ) AND ( ${VTK_MINOR_VERSION} GREATER 6 ))
    ADD_DEFINITIONS( -DVTKTRUNK )
  ENDIF( ( ${VTK_MAJOR_VERSION} EQUAL 5 ) AND ( ${VTK_MINOR_VERSION} GREATER 6 ))

  INCLUDE( ${VTK_USE_FILE} )

  IF( ${VTK_USE_MYSQL} MATCHES "ON" )
    FIND_PACKAGE( MySQL REQUIRED )
    SET( MYSQL_LIBRARIES ${MYSQL_LIBRARIES} CACHE FILEPATH "" )
#    SET( MYSQL_EXTRA_LIBRARIES ${MYSQL_EXTRA_LIBRARIES} CACHE FILEPATH "" )
  ELSE( ${VTK_USE_MYSQL} MATCHES "ON" )
    MESSAGE( SEND_ERROR "VTK must be compiled with MySQL support" )
    # TODO (arnaudgelas)
    # Here add a definition to be able to compile and use GoFigure
    # without any database support
    # ADD_DEFINITION( -DNODBSUPPORT )
  ENDIF( ${VTK_USE_MYSQL} MATCHES "ON" )

  #----------------------------------------------------------
  # Determine if GoFigure has to be built in shared or static
  # based on the configuration of VTK
  IF( VTK_BUILD_SHARED_LIBS )
    SET( LIBS_STYLE "SHARED" )
    SET( BUILD_SHARED_LIBS "TRUE" )
    ADD_DEFINITIONS( -DGOFIGURE2_BUILD_SHARED_LIBS )
  ELSE( VTK_BUILD_SHARED_LIBS )
    SET( LIBS_STYLE "STATIC" )
    SET( BUILD_SHARED_LIBS "FALSE" )
    REMOVE_DEFINITIONS( -DGOFIGURE2_BUILD_SHARED_LIBS )
  ENDIF( VTK_BUILD_SHARED_LIBS )
  #----------------------------------------------------------

  #----------------------------------------------------------
  # Then find ITK
  #### ITK ####
  FIND_PACKAGE( ITK REQUIRED )
  IF( ITK_FOUND )
    INCLUDE( ${ITK_USE_FILE} )

    IF( ( ${ITK_VERSION_MAJOR} LESS 3 ) OR
        ( ( ${ITK_VERSION_MAJOR} EQUAL 3 ) AND
          ( ${ITK_VERSION_MINOR} LESS 18 ) ) )
      MESSAGE( SEND_ERROR
        "GoFigure2 requires ITK 3.18 or newer version (your version of ITK is ${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR}.${ITK_VERSION_PATCH})" )
    ENDIF( ( ${ITK_VERSION_MAJOR} LESS 3 ) OR
        ( ( ${ITK_VERSION_MAJOR} EQUAL 3 ) AND
          ( ${ITK_VERSION_MINOR} LESS 18 ) ) )

    SET( ITK_VERSION_MAJOR ${ITK_VERSION_MAJOR}
      CACHE STRING INTERNAL )
    SET( ITK_VERSION_MINOR ${ITK_VERSION_MINOR}
      CACHE STRING INTERNAL )

    MARK_AS_ADVANCED( ITK_VERSION_MAJOR ITK_VERSION_MINOR )

  IF( ${ITK_VERSION_MAJOR} EQUAL 3 )
    IF( ( ${ITK_USE_REVIEW} MATCHES "OFF" ) OR
        ( ${ITK_USE_REVIEW_STATISTICS} MATCHES "OFF" ) )
      MESSAGE( SEND_ERROR
        "GoFigure2 requires ITK to be compiled with USE_REVIEW and USE_REVIEW_STATISTICS turned ON" )
     ENDIF( ( ${ITK_USE_REVIEW} MATCHES "OFF" ) OR
        ( ${ITK_USE_REVIEW_STATISTICS} MATCHES "OFF" ) )
  ELSE( ${ITK_VERSION_MAJOR} EQUAL 3 )
    IF( ${ITK_USE_REVIEW} MATCHES "OFF" )
      MESSAGE( SEND_ERROR
        "GoFigure2 requires ITK to be compiled with USE_REVIEW turned ON" )
    ENDIF( ${ITK_USE_REVIEW} MATCHES "OFF" )

  ENDIF( ${ITK_VERSION_MAJOR} EQUAL 3 )

  ENDIF( ITK_FOUND )
  #----------------------------------------------------------

  #----------------------------------------------------------
  # Then find Boost. Note that we only need headers
  #### BOOST ####
  FIND_PACKAGE( Boost REQUIRED )
  IF( Boost_FOUND )
    INCLUDE_DIRECTORIES( BEFORE ${Boost_INCLUDE_DIRS} )
  ENDIF( Boost_FOUND )

  # Try to find Qt.
  # Note that some command line tools will get compiled even without Qt
  #### Qt ####
  FIND_PACKAGE( Qt4 REQUIRED )
  IF( QT4_FOUND AND QT_VERSION_MINOR GREATER 4 )
    IF( QT_USE_FILE )
      SET( QT_USE_QT3SUPPORT FALSE )
      SET( QT_USE_QTCORE TRUE )
      SET( QT_USE_QTGUI TRUE )
      INCLUDE( ${QT_USE_FILE} )
    ELSE( QT_USE_FILE )
      SET( QT_LIBRARIES ${QT_QT_LIBRARY} )
    ENDIF( QT_USE_FILE )

    SET( QT_VERSION_MINOR ${QT_VERSION_MINOR}
      CACHE STRING INTERNAL )
    SET( QT_VERSION_PATCH ${QT_VERSION_PATCH}
      CACHE STRING INTERNAL )

    MARK_AS_ADVANCED( QT_VERSION_MINOR QT_VERSION_PATCH )

    SET( QT_PLUGIN_LIBS ${QT_LIBRARIES} )

    ADD_DEFINITIONS( ${QT_DEFINITIONS} )
    #
    # ADD_DEFINITIONS( -DQT_GUI_LIBS )
    # ADD_DEFINITIONS( -DQT_CORE_LIB )

    SET( GOFIGURE2_EXTERNAL_SOURCE_DIR
      ${GOFIGURE2_SOURCE_DIR}/Code/ExternalCode )
    SET( GOFIGURE2_EXTERNAL_BINARY_DIR
      ${GOFIGURE2_BINARY_DIR}/Code/ExternalCode )

    SET( MEGAVTK2_SOURCE_DIR ${GOFIGURE2_EXTERNAL_SOURCE_DIR}/MegaVTK )
    SET( MEGAVTK2_BINARY_DIR ${GOFIGURE2_EXTERNAL_BINARY_DIR}/MegaVTK )

    LINK_DIRECTORIES(
      ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
      ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}
      ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
      )


    INCLUDE_DIRECTORIES( BEFORE
      ${QT_INCLUDES}
      ${GOFIGURE2_SOURCE_DIR}/Code/
      ${GOFIGURE2_BINARY_DIR}/Code/
      ${GOFIGURE2_SOURCE_DIR}/Code/IO/
      ${GOFIGURE2_BINARY_DIR}/Code/IO/
      ${GOFIGURE2_SOURCE_DIR}/Code/Filters/
      ${GOFIGURE2_BINARY_DIR}/Code/Filters/
      ${GOFIGURE2_SOURCE_DIR}/Code/GUI/
      ${GOFIGURE2_BINARY_DIR}/Code/GUI/
      ${GOFIGURE2_SOURCE_DIR}/Code/GUI/lib/
      ${GOFIGURE2_BINARY_DIR}/Code/GUI/lib/
      ${GOFIGURE2_BINARY_DIR}/Code/GUI/lib/Resources/
      ${GOFIGURE2_SOURCE_DIR}/Interfaces/
      ${GOFIGURE2_BINARY_DIR}/Interfaces/
      ${GOFIGURE2_SOURCE_DIR}/Code/GUI/src/
      ${GOFIGURE2_BINARY_DIR}/Code/GUI/src/
      ${MEGAVTK2_SOURCE_DIR}
      ${MEGAVTK2_BINARY_DIR}
      ${MEGAVTK2_SOURCE_DIR}/vtkItk
      ${MEGAVTK2_BINARY_DIR}/vtkItk
      ${MEGAVTK2_SOURCE_DIR}/vtkRenderingAddOn
      ${MEGAVTK2_BINARY_DIR}/vtkRenderingAddOn
      ${GOFIGURE2_EXTERNAL_SOURCE_DIR}/vtkLSM
      ${GOFIGURE2_EXTERNAL_BINARY_DIR}/vtkLSM
      ${GOFIGURE2_EXTERNAL_BINARY_DIR}/itkQt
      ${GOFIGURE2_EXTERNAL_SOURCE_DIR}/itkQt
      ${GOFIGURE2_EXTERNAL_SOURCE_DIR}/PoissonReconstruction
      ${GOFIGURE2_EXTERNAL_BINARY_DIR}/PoissonReconstruction
      ${GOFIGURE2_EXTERNAL_SOURCE_DIR}/ctk
      ${GOFIGURE2_EXTERNAL_BINARY_DIR}/ctk
      ${GOFIGURE2_SOURCE_DIR}/Main
      ${GOFIGURE2_BINARY_DIR}/Main
    )

    # Try to extract Qt variable from VTK

=== Main/CMakeLists.txt ===
CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/gofigure.cxx.in
  ${CMAKE_CURRENT_BINARY_DIR}/gofigure.cxx @ONLY IMMEDIATE
)

SET( QGoMainWindow_UI
  go.ui
)

SET( QGoGUISRC_HDRS
  QGoTabManager.h
  QGoMainWindow.h
  QGoPluginManager.h
  ${QGoGUIINTERFACES_HDRS}
)

SET( GOFIGURE_MAIN
  ${CMAKE_CURRENT_BINARY_DIR}/gofigure.cxx
)

SET( GOFIGURE_APPLICATION_SOURCE_LIST
  QGoTabManager.cxx
  QGoMainWindow.cxx
  QGoPluginManager.cxx
  )

IF( BUILD_COMPARETOOL )
  SET( QGoGUISRC_HDRS
    ${QGoGUISRC_HDRS}
    QGoSynchronizedViewMainWindow.h
  )

  SET( GOFIGURE_APPLICATION_SOURCE_LIST
    ${GOFIGURE_APPLICATION_SOURCE_LIST}
    ${QGoSynchronizedViewMainWindow.cxx}
  )
ENDIF( BUILD_COMPARETOOL )

INCLUDE_DIRECTORIES( ${GOFIGURE2_BINARY_DIR}/Main/  )

QT4_WRAP_UI( QGoMainWindow_UI_H ${QGoMainWindow_UI} )

QT4_WRAP_CPP( QGoGUISRC_MOC ${QGoGUISRC_HDRS} )

SET_SOURCE_FILES_PROPERTIES(
  ${GOFIGURE_APPLICATION_SOURCE_LIST}
  PROPERTIES
  OBJECT_DEPENDS "${QGoMainWindow_UI_H}"
  )

SET_SOURCE_FILES_PROPERTIES(
  ${QGoGUISRC_MOC}
  PROPERTIES
  OBJECT_DEPENDS "${QGoMainWindow_UI_H}"
  )

QT4_ADD_RESOURCES( QGoMainWindow_QRC
  ${QGoResourceFile}
  )

SET( QGoGUISRC_SRC
  ${QGoGUISRC_CXX}
  ${QGoGUISRC_MOC}
)

set( qt_menu_nib_sources )

IF( APPLE )

  IF(QT_MAC_USE_COCOA)
    GET_FILENAME_COMPONENT( qt_menu_nib
     "@QT_QTGUI_LIBRARY_RELEASE@/Resources/qt_menu.nib"
      REALPATH )
    set( qt_menu_nib_sources
      "${qt_menu_nib}/classes.nib"
      "${qt_menu_nib}/info.nib"
      "${qt_menu_nib}/keyedobjects.nib"
      )
    SET_SOURCE_FILES_PROPERTIES(
      ${qt_menu_nib_sources}
      PROPERTIES
      MACOSX_PACKAGE_LOCATION Resources/qt_menu.nib
      )
  ENDIF(QT_MAC_USE_COCOA)

  SET( MACOSX_BUNDLE_ICON_FILE
    ${GOFIGURE2_SOURCE_DIR}/Resources/myapp.icns
    )

  SET_SOURCE_FILES_PROPERTIES(
    ${MACOSX_BUNDLE_ICON_FILE}
    PROPERTIES
    MACOSX_PACKAGE_LOCATION Resources
    )

  SET( GOFIGURE_APPLICATION_SOURCE_LIST
    ${GOFIGURE_APPLICATION_SOURCE_LIST}
    ${MACOSX_BUNDLE_ICON_FILE}
    )

  SET( MACOSX_BUNDLE_SHORT_VERSION_STRING
    ${GOFIGURE2_VERSION}
    )

  SET( MACOSX_BUNDLE_VERSION
    ${GOFIGURE2_VERSION}
    )

  SET( MACOSX_BUNDLE_LONG_VERSION_STRING
    Version ${GOFIGURE2_VERSION}
    )

ENDIF( APPLE )

IF( WIN32 )
  IF( MINGW )
    ADD_CUSTOM_COMMAND( OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/myapp.o
      COMMAND windres.exe -I${CMAKE_CURRENT_SOURCE_DIR}
        -i ${GOFIGURE2_SOURCE_DIR}/Resources/myapp.rc
        -o ${CMAKE_CURRENT_BINARY_DIR}/myapp.o
        )

    SET( ${GOFIGURE_APPLICATION_SOURCE_LIST}
      ${GOFIGURE_APPLICATION_SOURCE_LIST}
      ${CMAKE_CURRENT_BINARY_DIR}/myapp.o
      )
  ELSE( MINGW )
    SET( GOFIGURE_APPLICATION_SOURCE_LIST
      ${GOFIGURE_APPLICATION_SOURCE_LIST}
      ${GOFIGURE2_SOURCE_DIR}/Resources/myapp.rc
      )
  ENDIF( MINGW )

  #-------------------------------------------------------------------------
  # This sets the windows build that will need the special winmain@16 call.
  # Qt provides this for us in the qtmain.lib file. Using this cmake code
  # will ensure we have it linked into our build. Not needed on
  # Unix/OS X/Linux which is why we have the IF(WIN32) conditional.
  SET( QT_USE_QTMAIN TRUE )

ENDIF( WIN32 )

# --------
# gofigure
ADD_EXECUTABLE( gofigure
  MACOSX_BUNDLE
  ${GOFIGURE_MAIN}
  ${GOFIGURE_APPLICATION_SOURCE_LIST}
  ${QGoGUIINTERFACES_SRC}
  ${QGoGUISRC_MOC}
  ${QGoMainWindow_QRC}
  ${qt_menu_nib_sources}
)

TARGET_LINK_LIBRARIES( gofigure
  QGoGui
  QGoIO
  itkQt
 )

IF( BUILD_COMPARETOOL )
  # comparegui

  ADD_EXECUTABLE( comparegui
    comparegui.cxx
    ${GOFIGURE_APPLICATION_SOURCE_LIST}
    ${QGoGUIINTERFACES_SRC}
    ${QGoGUISRC_MOC}
    ${QGoMainWindow_QRC}
    ${qt_menu_nib_sources}
  )

  TARGET_LINK_LIBRARIES( comparegui
    QGoGui
    QGoIO
    itkQt
  )
ENDIF( BUILD_COMPARETOOL )


#---------------------------------------------------------------------------
# Now the installation stuff below
#---------------------------------------------------------------------------
SET( plugin_dest_dir ${GOFIGURE2_INSTALL_BIN_DIR} )
SET( qtconf_dest_dir ${GOFIGURE2_INSTALL_BIN_DIR} )

IF( APPLE )
  SET( plugin_dest_dir gofigure.app/Contents/MacOS )
  SET( qtconf_dest_dir gofigure.app/Contents/Resources )
  SET( APPS
    "\${CMAKE_INSTALL_PREFIX}/${GOFIGURE2_INSTALL_BUNDLE_DIR}/gofigure.app" )
ENDIF( APPLE )

IF( WIN32 )
  SET( APPS
    "\${CMAKE_INSTALL_PREFIX}/${GOFIGURE2_INSTALL_BIN_DIR}/gofigure.exe" )
ENDIF(WIN32)

IF( UNIX AND NOT APPLE )
  SET( APPS
    "\${CMAKE_INSTALL_PREFIX}/${GOFIGURE2_INSTALL_BIN_DIR}/gofigure" )

  IF( NOT DESKTOP_ENTRY )
    SET( DESKTOP_ENTRY gofigure2.desktop )
  ENDIF( NOT DESKTOP_ENTRY )

  CONFIGURE_FILE( ${GOFIGURE2_SOURCE_DIR}/Main/gf2-desktop.sh.in
    ${GOFIGURE2_BINARY_DIR}/Main/gf2-desktop.sh @ONLY IMMEDIATE
  )

  ADD_CUSTOM_COMMAND( OUTPUT ${DESKTOP_ENTRY}
    COMMAND touch ${DESKTOP_ENTRY}
    COMMAND sh ${GOFIGURE2_BINARY_DIR}/Main/gf2-desktop.sh
      ${CMAKE_INSTALL_PREFIX} >${DESKTOP_ENTRY}
    DEPENDS ${GOFIGURE2_BINARY_DIR}/Main/gf2-desktop.sh
    COMMENT "Generating desktop entry file"
  )

  ADD_CUSTOM_TARGET( DESKTOP_ENTRY_FILE ALL
    DEPENDS ${DESKTOP_ENTRY}
  )

  SET( GOFIGURE2_ICON ${GOFIGURE2_SOURCE_DIR}/Resources/fig/Myapp2.png )

  INSTALL( FILES ${GOFIGURE2_ICON}
    DESTINATION share/gofigure2/icons COMPONENT Runtime )
ENDIF( UNIX AND NOT APPLE )

# MESSAGE( ${APPS} )

#---------------------------------------------------------------------------
# Install gofigure, on Apple, the bundle is at the root of the
# install tree, and on other platforms it'll go into the bin directory.

INSTALL( TARGETS gofigure
  ARCHIVE DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} COMPONENT Libraries
  LIBRARY DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} COMPONENT Libraries
  RUNTIME DESTINATION ${GOFIGURE2_INSTALL_BIN_DIR} COMPONENT Runtime
  BUNDLE  DESTINATION ${GOFIGURE2_INSTALL_BUNDLE_DIR} COMPONENT Runtime
  )

#-----------------------------------------------------
# Here Let's take care of License files
# copying them into the build's folder
# and during the installation process
FILE( GLOB
  GOFIGURE2_LICENSE_FILES
  "${GOFIGURE2_SOURCE_DIR}/Licenses/*.txt"
  )

IF( UNIX AND NOT APPLE )
  ADD_CUSTOM_COMMAND( TARGET gofigure POST_BUILD
    COMMENT "Copying License files..."
    COMMAND mkdir ARGS -p
      ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/Licenses
    COMMAND cp ARGS -rf
      ${GOFIGURE2_SOURCE_DIR}/Licenses/*.txt
      ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/Licenses
  )
ELSE( UNIX AND NOT APPLE )
  IF( WIN32 )
    FILE( TO_NATIVE_PATH ${GOFIGURE2_SOURCE_DIR} GOFIGURE2_SRC_DIR_WIN )
    FILE( TO_NATIVE_PATH ${CMAKE_RUNTIME_OUTPUT_DIRECTORY} OUTPUT_DIR_WIN )

    ADD_CUSTOM_COMMAND( TARGET gofigure POST_BUILD
      COMMENT "Copying License files..."
      COMMAND if not exist \"${OUTPUT_DIR_WIN}\\Licenses\"
        mkdir \"${OUTPUT_DIR_WIN}\\Licenses\"
      COMMAND xcopy ARGS /Y
        \"${GOFIGURE2_SRC_DIR_WIN}\\Licenses\\*.txt\"
        \"${OUTPUT_DIR_WIN}\\Licenses\\\"
     )
  ELSE( WIN32 )
    IF( APPLE )
      ADD_CUSTOM_COMMAND( TARGET gofigure POST_BUILD
        COMMENT "Copying License files..."
        COMMAND mkdir ARGS -p
          ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${plugin_dest_dir}/Licenses
        COMMAND cp ARGS -rf
          ${GOFIGURE2_SOURCE_DIR}/Licenses/*.txt
          ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${plugin_dest_dir}/Licenses
        )
    ENDIF( APPLE )
  ENDIF( WIN32 )
ENDIF( UNIX AND NOT APPLE )
#-----------------------------------------------------

#---------------------------------------------------------------------------
# Use BundleUtilities to get all other dependencies for the application to
# work. It takes a bundle or executable along with possible plugins and
# inspects it for dependencies.  If they are not system dependencies,
# they are copied.

# directories to look for dependencies
SET( DIRS
  ${QT_LIBRARY_DIR}
  ${QT_PLUGINS_DIR}
  ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
  ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}
  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
  ${ITK_LIBRARY_DIRS}
  ${VTK_LIBRARY_DIRS}
)

# Now the work of copying dependencies into the bundle/package
# The quotes are escaped and variables to use at install time have their $ i# escaped
# An alternative is the do a configure_file() on a script and use
# install(SCRIPT  ...).
# Note that the image plugins depend on QtSvg and QtXml, and it got those
# copied over.
INSTALL( CODE "
    file( GLOB_RECURSE QTPLUGINS
    \"\${CMAKE_INSTALL_PREFIX}/${plugin_dest_dir}/plugins/*${CMAKE_SHARED_LIBRARY_SUFFIX}\" )
    include( BundleUtilities )
    fixup_bundle(\"${APPS}\" \"\${QTPLUGINS}\" \"${DIRS}\")
  "
  COMPONENT Runtime )

IF( APPLE )
  #---------------------------------------------------------------------------
  # install a qt.conf file
  # this inserts some cmake code into the install script to write the file
  INSTALL( CODE "
    file( WRITE \"\${CMAKE_INSTALL_PREFIX}/${GOFIGURE2_INSTALL_BUNDLE_DIR}/${qtconf_dest_dir}/qt.conf\" \"\")
    " COMPONENT Runtime
    )

  INSTALL( FILES ${GOFIGURE2_LICENSE_FILES}
    DESTINATION ${plugin_dest_dir}/Licenses
    COMPONENT Runtime
    )
ELSE( APPLE )
  INSTALL( FILES ${GOFIGURE2_LICENSE_FILES}
    DESTINATION ${GOFIGURE2_INSTALL_LICENSE_DIR}
    COMPONENT Runtime
    )
ENDIF( APPLE )

FILE( GLOB __source_file_h "${CMAKE_CURRENT_SOURCE_DIR}/*.h" )

INSTALL( FILES ${__source_file_h} ${QGoMainWindow_UI_H}
  DESTINATION ${GOFIGURE2_INSTALL_HEADER_DIR}
  COMPONENT Development
)

=== Code/Filters/CMakeLists.txt ===
FILE( GLOB __source_file_h "${CMAKE_CURRENT_SOURCE_DIR}/*.h" )
FILE( GLOB __source_file_txx "${CMAKE_CURRENT_SOURCE_DIR}/*.txx" )

INSTALL( FILES ${__source_file_h} ${__source_file_txx}
  DESTINATION ${GOFIGURE2_INSTALL_HEADER_DIR}
  COMPONENT Development
)

=== Code/IO/CMakeLists.txt ===
IF( WIN32 )
  IF( NOT CYGWIN )
    IF( NOT MINGW )
      IF( BUILD_SHARED_LIBS )
        ADD_DEFINITIONS( -DQGoIO_EXPORT )
      ENDIF( BUILD_SHARED_LIBS )
    ENDIF( NOT MINGW )
  ENDIF( NOT CYGWIN )
ENDIF( WIN32 )

CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/QGoIOConfigure.h.in
 ${CMAKE_CURRENT_BINARY_DIR}/QGoIOConfigure.h
 @ONLY IMMEDIATE
)

SET( QGOIO_SRC
  TraceStructure.cxx
  ContourMeshStructure.cxx
  TrackStructure.cxx
  CreateDataBaseHelper.cxx
  GoDBAuthorRow.cxx
  GoDBChannelRow.cxx
  GoDBCollectionOfTraces.cxx
  GoDBColorRow.cxx
  GoDBContourRow.cxx
  GoDBCoordinateRow.cxx
  GoDBImageRow.cxx
  GoDBImgSessionRow.cxx
  GoDBMeshRow.cxx
  GoDBProjectRow.cxx
  GoDBTraceRow.cxx
  GoDBRow.cxx
  GoDBTrackRow.cxx
  GoDBLineageRow.cxx
  GoDBNameDescRow.cxx
  GoDBBookmarkRow.cxx
  GoDBCellTypeRow.cxx
  GoDBSubCellTypeRow.cxx
  GoDBIntensityRow.cxx
  GoDBTableWidgetContainer.cxx
  GoDBTWContainerForContourMesh.cxx
  GoDBTWContainerForTrackLineage.cxx
  GoDBTWContainerForMesh.cxx
  GoDBTWContainerForTrack.cxx
  GoDBExport.cxx
  GoDBImport.cxx
  MegaCaptureHeaderReader.cxx
  QueryDataBaseHelper.cxx
  SelectQueryDatabaseHelper.cxx
  QueryBuilderHelper.cxx
  # itkLsm3DSerieImport.cxx
  itkMegaCaptureImport.cxx
  itkMegaCaptureReader.cxx
  GoFigureFileInfoMultiIndexContainerHelper.cxx
  vtkPolyDataMySQLContourReader.cxx
  vtkPolyDataMySQLMeshReader.cxx
  vtkPolyDataMySQLTrackReader.cxx
  vtkPolyDataMySQLContourWriter.cxx
  vtkPolyDataMySQLMeshWriter.cxx
  vtkPolyDataMySQLTrackWriter.cxx
  LSMToMegaCapture.cxx
#  MeshTextFileImport.cxx
#  TrackTextFileImport.cxx
)

ADD_LIBRARY( QGoIO
  ${QGOIO_SRC}
)

ADD_DEPENDENCIES( QGoIO vtkLSMReader )

TARGET_LINK_LIBRARIES( QGoIO
  ${QT_LIBRARIES}
  QGoIO
  vtkHybrid
  vtkIO
  vtkImaging
  vtkLSMReader
  ITKCommon
  ITKIO
)

SET_TARGET_PROPERTIES( QGoIO PROPERTIES VERSION ${GOFIGURE2_LIB_VERSION} SOVERSION ${GOFIGURE2_LIB_VERSION} )

# Runtime
INSTALL( TARGETS QGoIO
  EXPORT GoFigure2Targets
  RUNTIME DESTINATION ${GOFIGURE2_INSTALL_BIN_DIR} COMPONENT Runtime
  ARCHIVE DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} COMPONENT Libraries
  LIBRARY DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} NAMELINK_SKIP COMPONENT Libraries
  )

# Development
INSTALL( TARGETS QGoIO
  EXPORT GoFigure2Targets
  RUNTIME DESTINATION ${GOFIGURE2_INSTALL_BIN_DIR} COMPONENT Runtime
  ARCHIVE DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} COMPONENT Libraries
  LIBRARY DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} COMPONENT Libraries NAMELINK_ONLY
  )

FILE( GLOB __source_file_h "${CMAKE_CURRENT_SOURCE_DIR}/*.h" )
FILE( GLOB __source_file_txx "${CMAKE_CURRENT_SOURCE_DIR}/*.txx" )

FILE( GLOB __binary_file_h "${CMAKE_CURRENT_BINARY_DIR}/*.h" )
FILE( GLOB __binary_file_txx "${CMAKE_CURRENT_BINARY_DIR}/*.txx" )

INSTALL( FILES ${__source_file_h} ${__source_file_txx}
    ${__binary_file_h} ${__binary_file_txx}
  DESTINATION ${GOFIGURE2_INSTALL_HEADER_DIR}
  COMPONENT Development
)

=== Examples/Filters/CMakeLists.txt ===
ADD_EXECUTABLE( itkvtkPolyDatatoBinaryMaskImageFilterTest
  itkvtkPolyDatatoBinaryMaskImageFilterTest.cxx )

TARGET_LINK_LIBRARIES( itkvtkPolyDatatoBinaryMaskImageFilterTest
  ITKIO
  ITKCommon
  vtkGraphics
  vtkHybrid
)

ADD_TEST( itkvtkPolyDatatoBinaryMaskImageFilterTest
  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/itkvtkPolyDatatoBinaryMaskImageFilterTest
  ${TESTING_DATA_PATH}/Circle3D.mhd
  temp.mhd
)

ADD_EXECUTABLE( itkBinaryMaskImageToGoFigureMeshAttributesTest
 itkBinaryMaskImageToGoFigureMeshAttributesTest.cxx )
TARGET_LINK_LIBRARIES( itkBinaryMaskImageToGoFigureMeshAttributesTest
  QGoGui
)

ADD_TEST( itkBinaryMaskImageToGoFigureMeshAttributesTest
  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/itkBinaryMaskImageToGoFigureMeshAttributesTest
  ${TESTING_DATA_PATH}/Circle3D.mhd
  temp.mhd
)

ADD_EXECUTABLE( itkvtkPolyDataToGoFigureMeshAttributesTest
 itkvtkPolyDataToGoFigureMeshAttributesTest.cxx )
TARGET_LINK_LIBRARIES( itkvtkPolyDataToGoFigureMeshAttributesTest
  QGoGui
  vtkGraphics
  vtkHybrid
)

ADD_TEST( itkvtkPolyDataToGoFigureMeshAttributesTest
  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/itkvtkPolyDataToGoFigureMeshAttributesTest
  ${TESTING_DATA_PATH}/Circle3D.mhd
)

SET_TESTS_PROPERTIES( itkBinaryMaskImageToGoFigureMeshAttributesTest
  PROPERTIES DEPENDS
  itkvtkPolyDatatoBinaryMaskImageFilterTest
)

ADD_EXECUTABLE( ContourToMeshFilterTest
  ContourToMeshFilterTest.cxx
  )
TARGET_LINK_LIBRARIES( ContourToMeshFilterTest
  PoissonReconstruction
  vtkHybrid
  vtkRenderingAddOn2
  ITKCommon
  )

ADD_TEST( ContourToMeshFilterTest
 ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/ContourToMeshFilterTest
 1
 )

=== Examples/IO/CMakeLists.txt ===
SET( QGOIO_EXAMPLES_SRC
  megacaptureimport
  gofigurefileinfomultiindexcontainerhelper
  MegaCaptureHeaderReaderTest
  lsm2mha
  lsmtomegacapture
  itkmegacapturereader
  GenerateImagingSessionPartInMegaCaptureHeaderFromMHA
  mhatomegacapture
  vtkPolyDataMySQLContourReader
  vtkPolyDataMySQLMeshReader
  vtkPolyDataMySQLContourWriter
  vtkPolyDataMySQLMeshWriter
  vtkPolyDataMySQLTrack
#  kishmeshtextfilereader
#  trackTextFilesReader
)

SET( GODB_SRC
  GoDBTraceRowTest
  GoDBContourRowTest
  GoDBMeshRowTest
  GoDBTrackRowTest
  GoDBLineageRowTest
  GoDBColorRowTest
  GoDBChannelRowTest
  GoDBBookmarkRowTest
  GoDBImageRowTest
  GoDBIntensityRowTest
  GoDBProjectRowTest
  GoDBCoordinateRowTest
  GoDBImgSessionRowTest
  GoDBImportTracksTest
)

SET( QGOIO_EXAMPLES_SRC
  ${QGOIO_EXAMPLES_SRC}
  ${GODB_SRC}
)

FOREACH( var ${QGOIO_EXAMPLES_SRC} )
  ADD_EXECUTABLE( ${var} ${var}.cxx )
  TARGET_LINK_LIBRARIES( ${var}
    QGoIO
  )
ENDFOREACH( var ${QGOIO_EXAMPLES_SRC} )

ADD_TEST( gofigurefileinfomultiindexcontainerhelperTest
  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/gofigurefileinfomultiindexcontainerhelper )

ADD_TEST( vtkPolyDataMySQLContourReaderTest
  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/vtkPolyDataMySQLContourReader
  ${TESTING_DATA_PATH}/contour.vtk
)

ADD_TEST( vtkPolyDataMySQLMeshReaderTest
  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/vtkPolyDataMySQLMeshReader
  ${TESTING_DATA_PATH}/sphere.vtk
)

ADD_TEST( vtkPolyDataMySQLTrackTest
  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/vtkPolyDataMySQLTrack
)

ADD_TEST( vtkPolyDataMySQLContourWriterTest
  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/vtkPolyDataMySQLContourWriter
  ${TESTING_DATA_PATH}/contour.vtk
)

ADD_TEST( vtkPolyDataMySQLMeshWriterTest
  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/vtkPolyDataMySQLMeshWriter
  ${TESTING_DATA_PATH}/sphere.vtk
)

ADD_TEST( MegaCaptureHeaderReaderTest
  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/MegaCaptureHeaderReaderTest
  ${GOFIGURE2_BINARY_DIR}/Testing/earpax2isl11/earpax2isl11.lsm.meg  
)

ADD_TEST( lsmtomegacaptureTest
  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/lsmtomegacapture
  ${TESTING_DATA_PATH}/earpax2isl11.lsm
  ${GOFIGURE2_BINARY_DIR}/Testing/earpax2isl11_lsmtomegacapture/
  png
  )
  
FOREACH( var ${GODB_SRC} )
  ADD_TEST( ${var} 
    ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${var}
  )
ENDFOREACH( var ${GODB_SRC} )

=== Testing/Sikuli/CMakeLists.txt ===
ADD_SUBDIRECTORY( gofigure2_images )

=== Code/ExternalCode/itkQt/CMakeLists.txt ===
IF( WIN32 )
  IF( NOT CYGWIN )
    IF( NOT MINGW )
      IF( BUILD_SHARED_LIBS )
        ADD_DEFINITIONS( -DitkQt_EXPORT )
      ENDIF( BUILD_SHARED_LIBS )
    ENDIF( NOT MINGW )
  ENDIF( NOT CYGWIN )
ENDIF( WIN32 )


CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/itkQtConfigure.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/itkQtConfigure.h @ONLY IMMEDIATE )

QT4_WRAP_CPP( itkQtAdaptor_MOC itkQtAdaptor.h )

ADD_LIBRARY( itkQt
  itkQtProgressBar.cxx
  itkQtAdaptor.h
  ${itkQtAdaptor_MOC}
)

TARGET_LINK_LIBRARIES( itkQt
  ITKCommon
  ${QT_LIBRARIES}
  )

SET_TARGET_PROPERTIES( itkQt PROPERTIES VERSION ${GOFIGURE2_LIB_VERSION} SOVERSION ${GOFIGURE2_LIB_VERSION} )

# Runtime
INSTALL( TARGETS itkQt
  EXPORT GoFigure2Targets
  RUNTIME DESTINATION ${GOFIGURE2_INSTALL_BIN_DIR} COMPONENT Runtime
  LIBRARY DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} NAMELINK_SKIP COMPONENT Libraries
  ARCHIVE DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} COMPONENT Libraries
  )

# Development
INSTALL( TARGETS itkQt
  EXPORT GoFigure2Targets
  RUNTIME DESTINATION ${GOFIGURE2_INSTALL_BIN_DIR} COMPONENT Runtime
  LIBRARY DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} NAMELINK_ONLY COMPONENT Libraries
  ARCHIVE DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} COMPONENT Libraries
  )

FILE( GLOB __source_file_h "${CMAKE_CURRENT_SOURCE_DIR}/*.h" )
FILE( GLOB __binary_file_h "${CMAKE_CURRENT_BINARY_DIR}/*.h" )

INSTALL( FILES ${__source_file_h} ${__binary_file_h}
  DESTINATION ${GOFIGURE2_INSTALL_HEADER_DIR}
  COMPONENT Development
)

=== Code/GUI/lib/CMakeLists.txt ===
IF( WIN32 )
  IF( NOT CYGWIN )
    IF( NOT MINGW )
      IF( BUILD_SHARED_LIBS )
        ADD_DEFINITIONS( -DQGoGUI_EXPORT )
      ENDIF( BUILD_SHARED_LIBS )
    ENDIF( NOT MINGW )
  ENDIF( NOT CYGWIN )
ENDIF( WIN32 )

CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/QGoGUILibConfigure.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/QGoGUILibConfigure.h @ONLY IMMEDIATE )

CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/QGoAboutWidget.cxx.in
  ${CMAKE_CURRENT_BINARY_DIR}/QGoAboutWidget.cxx @ONLY IMMEDIATE )

CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/QGoNetworkUtilities.cxx.in
  ${CMAKE_CURRENT_BINARY_DIR}/QGoNetworkUtilities.cxx @ONLY IMMEDIATE )

SET( QGoGUILIB_SRC
  ContourContainer.cxx
  MeshContainer.cxx
  ContourMeshContainer.cxx
  TrackContainer.cxx
  QGoConnectServerPage.cxx
  QGoCreateImgSessionPage.cxx
  QGoImageView.cxx
  QGoImageView2D.cxx
  QGoImageView3D.cxx
  QGoImageInfo.cxx
  QGoLUTDialog.cxx
  QGoManualSegmentationSettingsDialog.cxx
  QGoOpenCreateImgSessionPage.cxx
  QGoOpenCreateProjectPage.cxx
  QGoPrintDatabase.cxx
  QGoTabElementBase.cxx
  QGoTabImageView2D.cxx
  QGoTabImageView3D.cxx
  QGoTabImageView3DwT.cxx
  QGoTabImageView4D.cxx
  QGoTabImageViewElementBase.cxx
  QGoTabImageViewNDBase.cxx
  QGoNavigationDockWidget.cxx
  QGoWizardDB.cxx
  QSplitterChild.cxx
  QGoTableWidget.cxx
  SnapshotHelper.cxx
  QGoCreateMeshDialog.cxx
  QGoLsmToMegaExportDialog.cxx
  ConversionLsmToMegaThread.cxx
  QGoDBBookmarkManager.cxx
  QTextEditChild.cxx
  QGoNameDescriptionInputDialog.cxx
  QGoDockWidgetStatus.cxx
  QGoDeleteFromListDialog.cxx
  QGoDBNameDescEntityManager.cxx
  QGoDBCellTypeManager.cxx
  QGoDBSubCellTypeManager.cxx
  QGoDBColorManager.cxx
  QGoTraceManualEditingWidget.cxx
  QGoTraceManualEditingDockWidget.cxx
  QGoDBInitializationWizard.cxx
  QGoDBInitCreateUserPage.cxx
  QGoDBInitCreateAuthorsPage.cxx
  QGoDBInitCreateMicroscopePage.cxx
  QGoColorComboBox.cxx
  QGoSelectedColorComboBox.cxx
  QGoCollectionColorComboBox.cxx
  QGoComboBox.cxx
  QGoDBTraceManager.cxx
  QGoDBContourManager.cxx
  QGoDBMeshManager.cxx
  QGoDBTrackManager.cxx
  QGoColorCodingDialog.cxx

  # base segmentation widgets
  QGoContourSegmentationBaseDockWidget.cxx
  QGoMeshSegmentationBaseDockWidget.cxx

  #--manual segmentation--
  QGoContourManualSegmentation.cxx
  QGoContourManualSegmentationWidget.cxx

  #--seed segmentation--
  QGoSeedSegmentationBase.cxx
    QGoContourSeedSegmentation.cxx
    QGoMeshSeedSegmentation.cxx
  QGoSeedBaseWidget.cxx
    QGoContourSemiAutoLevelsetWidget.cxx
    QGoContourSemiAutoShapeWidget.cxx
    QGoContourSemiAutoWatershedWidget.cxx
  QGoFilterSemiAutoBase.cxx
    QGoFilterChanAndVese.cxx
    QGoFilterShape.cxx
    QGoFilterWatershed.cxx

  # for the tracks
  QGoTrackDockWidget.cxx
  QGoTrackEditingWidget.cxx

  ${GOFIGURE2_BINARY_DIR}/Code/GUI/lib/QGoAboutWidget.cxx
  ${GOFIGURE2_BINARY_DIR}/Code/GUI/lib/QGoNetworkUtilities.cxx
)

IF( BUILD_COMPARETOOL )
  SET( QGoGUILIB_SRC
    ${QGoGUILIB_SRC}
    QGoSynchronizedView.cxx
    QGoSynchronizedView2D.cxx
    QGoSynchronizedView3D.cxx
    QGoSynchronizedView2DCallbacks.cxx
    QGoSynchronizedView3DCallbacks.cxx
    QGoSynchronizedViewManager.cxx
  )
ENDIF( BUILD_COMPARETOOL )

#---------------------------------------------------------------------------
#---------------------------------------------------------------------------

#ADD THIS SRCS IF ENABLE_VIDEO_RECORD is ON
IF( ENABLE_VIDEO_RECORD_FFMPEG )
  SET(QGoGUILIB_SRC
    ${QGoGUILIB_SRC}
    vtkRenderWindowMovieRecorder.cxx
    vtkFFMPEGRenderWindowRecorder.cxx
    QGoVideoRecorder.cxx
  )
ENDIF( ENABLE_VIDEO_RECORD_FFMPEG )

#ADD THIS SRCS IF ENABLE_VIDEO_RECORD is ON
IF( ENABLE_VIDEO_RECORD_AVI )
  SET(QGoGUILIB_SRC
    ${QGoGUILIB_SRC}
    vtkRenderWindowMovieRecorder.cxx
    vtkAVIRenderWindowRecorder.cxx
    QGoVideoRecorder.cxx
  )
ENDIF( ENABLE_VIDEO_RECORD_AVI )

#---------------------------------------------------------------------------
#---------------------------------------------------------------------------

SET( QGoGUILIB_HDRS
  ContourContainer.h
  MeshContainer.h
  ContourMeshContainer.h
  TrackContainer.h
  QGoConnectServerPage.h
  QGoCreateImgSessionPage.h
  QGoImageView.h
  QGoImageView2D.h
  QGoImageView3D.h
  QGoImageInfo.h
  QGoLUTDialog.h
  QGoManualSegmentationSettingsDialog.h
  QGoOpenCreateImgSessionPage.h
  QGoOpenCreateProjectPage.h
  QGoPrintDatabase.h
  QGoTabElementBase.h
  QGoTabImageView2D.h
  QGoTabImageView3D.h
  QGoTabImageView3DwT.h
  QGoTabImageView4D.h
  QGoTabImageViewElementBase.h
  QGoTabImageViewNDBase.h
  QGoNavigationDockWidget.h
  QGoWizardDB.h
  QSplitterChild.h
  QGoTableWidget.h
  QGoCreateMeshDialog.h
  QGoLsmToMegaExportDialog.h
  ConversionLsmToMegaThread.h
  QGoDBBookmarkManager.h
  QTextEditChild.h
  QGoNameDescriptionInputDialog.h
  QGoDockWidgetStatus.h
  QGoDeleteFromListDialog.h
  QGoDBNameDescEntityManager.h
  QGoDBCellTypeManager.h
  QGoDBSubCellTypeManager.h
  QGoDBColorManager.h
  QGoTraceManualEditingWidget.h
  QGoTraceManualEditingDockWidget.h
  QGoAboutWidget.h
  QGoDBInitializationWizard.h
  QGoDBInitCreateUserPage.h
  QGoDBInitCreateAuthorsPage.h
  QGoDBInitCreateMicroscopePage.h
  QGoNetworkUtilities.h
  QGoColorComboBox.h
  QGoSelectedColorComboBox.h
  QGoCollectionColorComboBox.h
  QGoComboBox.h
  QGoDBTraceManager.h
  QGoDBContourManager.h
  QGoDBMeshManager.h
  QGoDBTrackManager.h
  QGoColorCodingDialog.h

  # base segmentation widgets
  QGoContourSegmentationBaseDockWidget.h
  QGoMeshSegmentationBaseDockWidget.h

  #--manual segmentation--
  QGoContourManualSegmentation.h
  QGoContourManualSegmentationWidget.h

  #--seed segmentation--
  QGoSeedSegmentationBase.h
    QGoContourSeedSegmentation.h
    QGoMeshSeedSegmentation.h
  QGoSeedBaseWidget.h
    QGoContourSemiAutoLevelsetWidget.h
    QGoContourSemiAutoShapeWidget.h
    QGoContourSemiAutoWatershedWidget.h
  QGoFilterSemiAutoBase.h
    QGoFilterChanAndVese.h
    QGoFilterShape.h
    QGoFilterWatershed.h

  # for the tracks
  QGoTrackDockWidget.h
  QGoTrackEditingWidget.h
)

IF( BUILD_COMPARETOOL )
  SET( QGoGUILIB_HDRS
    ${QGoGUILIB_HDRS}
    QGoSynchronizedView.h
    QGoSynchronizedView2D.h
    QGoSynchronizedView3D.h
    QGoSynchronizedView2DCallbacks.h
    QGoSynchronizedView3DCallbacks.h
    QGoSynchronizedViewManager.h
  )
ENDIF( BUILD_COMPARETOOL )
#---------------------------------------------------------------------------
#---------------------------------------------------------------------------

# ADD THIS HEADERS IF ENABLE_VIDEO_RECORD_FFMPEG IS ON
IF( ENABLE_VIDEO_RECORD_FFMPEG )
  SET(QGoGUILIB_HDRS
    ${QGoGUILIB_HDRS}
    QGoVideoRecorder.h
  )
ENDIF( ENABLE_VIDEO_RECORD_FFMPEG )

# ADD THIS HEADERS IF ENABLE_VIDEO_RECORD_AVI IS ON
IF( ENABLE_VIDEO_RECORD_AVI )
  SET(QGoGUILIB_HDRS
    ${QGoGUILIB_HDRS}
    QGoVideoRecorder.h
  )
ENDIF( ENABLE_VIDEO_RECORD_AVI )

#---------------------------------------------------------------------------
#---------------------------------------------------------------------------

SET( QGoGUILIB_UI
#segmentation widget
  Resources/SegmentationBaseDockWidget.ui
  Resources/SegmentationSeedBaseWidget.ui

# manual contour segmentation dock widget
  Resources/ManualSegmentationSettingsDlg.ui
  Resources/ContourManualSegmentationWidget.ui
  Resources/ContourSemiAutoShapeWidget.ui

# other
  Resources/NavigationDockWidget.ui
  Resources/QGoPrintDatabase.ui
  Resources/LsmToMegaExportDialog.ui
  Resources/QNameDescriptionInputDialog.ui
  Resources/QGoTraceManualEditingWidget.ui

  # seed segmentation dock widgets
  Resources/BaseAlgoSegmentationDockWidget.ui
  Resources/LevelsetWidget.ui
  Resources/WatershedWidget.ui

  # for tracks
  Resources/TrackDockWidget.ui
  Resources/TrackEditingWidget.ui
)

IF( BUILD_COMPARETOOL )
  SET( QGoGUILIB_UI
    ${QGoGUILIB_UI}
    Resources/QGoSynchronizedView.ui
  )
ENDIF( BUILD_COMPARETOOL )

#---------------------------------------------------------------------------
#---------------------------------------------------------------------------

# ADD THIS UI IF ENABLE_VIDEO_RECORD_FFMPEG IS ON
IF( ENABLE_VIDEO_RECORD_FFMPEG )
  SET(QGoGUILIB_UI
    ${QGoGUILIB_UI}
    Resources/NewVideoRecorderDockWidget.ui
  )
ENDIF( ENABLE_VIDEO_RECORD_FFMPEG )

# ADD THIS UI IF ENABLE_VIDEO_RECORD_AVI IS ON
IF( ENABLE_VIDEO_RECORD_AVI )
  SET(QGoGUILIB_UI
    ${QGoGUILIB_UI}
    Resources/NewVideoRecorderDockWidget.ui
  )
ENDIF( ENABLE_VIDEO_RECORD_AVI )

#---------------------------------------------------------------------------
#---------------------------------------------------------------------------

QT4_WRAP_UI( QGoGUILIB_UI_H
  ${QGoGUILIB_UI}
)

QT4_WRAP_CPP( QGoGUILIB_MOC ${QGoGUILIB_HDRS} )

QT4_ADD_RESOURCES( QGoGUI_QRC
  ${QGoResourceFile}
)
SET_SOURCE_FILES_PROPERTIES( ${QGoGUILIB_SRC} PROPERTIES
  OBJECT_DEPENDS "${QGoGUILIB_UI_H}"
  )

SET_SOURCE_FILES_PROPERTIES( ${QGoGUILIB_MOC} PROPERTIES
  OBJECT_DEPENDS "${QGoGUILIB_UI_H}"
  )

ADD_LIBRARY( QGoGui
  ${QGoGUILIB_SRC}
  ${QGoGUILIB_MOC}
  ${QGoGUI_QRC}
)

SET( QGoGUI_LIBS
  QVTK
  QGoIO
  vtkRenderingAddOn2
  PoissonReconstruction
  ctk
  ITKIO
  ITKCommon
  ITKBasicFilters
  ITKStatistics
  )

IF( ( ITK_VERSION_MAJOR EQUAL 4 ) AND
    ( ITK_VERSION_MINOR EQUAL 0 ) AND
    ( ITK_VERSION_PATCH EQUAL 0 )
    )

  SET( QGoGUI_LIBS
    ${QGoGUI_LIBS}
    ITKReview
    )

ENDIF( ( ITK_VERSION_MAJOR EQUAL 4 ) AND
    ( ITK_VERSION_MINOR EQUAL 0 ) AND
    ( ITK_VERSION_PATCH EQUAL 0 )
  )


TARGET_LINK_LIBRARIES( QGoGui
  ${QGoGUI_LIBS}
  )


SET_TARGET_PROPERTIES( QGoGui PROPERTIES VERSION ${GOFIGURE2_LIB_VERSION} SOVERSION ${GOFIGURE2_LIB_VERSION} )

# Runtime
INSTALL( TARGETS QGoGui
  EXPORT GoFigure2Targets
  RUNTIME DESTINATION ${GOFIGURE2_INSTALL_BIN_DIR} COMPONENT Runtime
  ARCHIVE DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} COMPONENT Libraries
  LIBRARY DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} NAMELINK_SKIP COMPONENT Libraries
  )

# Development
INSTALL( TARGETS QGoGui
  EXPORT GoFigure2Targets
  RUNTIME DESTINATION ${GOFIGURE2_INSTALL_BIN_DIR} COMPONENT Runtime
  ARCHIVE DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} COMPONENT Libraries
  LIBRARY DESTINATION ${GOFIGURE2_INSTALL_LIB_DIR} COMPONENT Libraries NAMELINK_ONLY
  )

FILE( GLOB __source_file_h "${CMAKE_CURRENT_SOURCE_DIR}/*.h" )
FILE( GLOB __source_file_txx "${CMAKE_CURRENT_SOURCE_DIR}/*.txx" )
FILE( GLOB __binary_file_h "${CMAKE_CURRENT_BINARY_DIR}/*.h" )

INSTALL(
  FILES ${__source_file_h} ${__source_file_txx} ${__binary_file_h}
    ${QGoGUILIB_UI_H}
  DESTINATION ${GOFIGURE2_INSTALL_HEADER_DIR}
  COMPONENT Development
)

=== Testing/Sikuli/gofigure2_images/CMakeLists.txt ===
SET( SIKULI_SCRIPTS_DIR
     ${GOFIGURE2_SOURCE_DIR}/Testing/Sikuli/gofigure2_images )

SET( SIKULI_SCRIPTS_BINARY_DIR
    ${GOFIGURE2_BINARY_DIR}/Testing/Sikuli/gofigure2_images )

CONFIGURE_FILE( ${SIKULI_SCRIPTS_DIR}/sikuli_test_all.sh.in
        ${GOFIGURE2_BINARY_DIR}/sikuli_test_all.sh
        @ONLY
        )

IF( UNIX AND NOT APPLE )

  ADD_TEST( SikuliTest1
    ${SH_EXECUTABLE} ${GOFIGURE2_BINARY_DIR}/sikuli_test_all.sh
  )

ENDIF( UNIX AND NOT APPLE )

=== debian/changelog ===
gofigure2 (0.8.1-2) unstable; urgency=low

  * Fix armel compilation
  * Add missing license files in help

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Mon, 18 Apr 2011 21:08:58 +0200

gofigure2 (0.8.1-1) unstable; urgency=low

  * Initial release (Closes: #587051)

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Thu, 10 Mar 2011 17:28:10 +0100

=== debian/control ===
Source: gofigure2
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Mathieu Malaterre <mathieu.malaterre@gmail.com>,
Build-Depends: debhelper (>= 7.0.50~), cmake (>= 2.8.2), libboost-all-dev, libqt4-dev, libinsighttoolkit3-dev (>= 3.20), libvtk5-qt4-dev (>= 5.6),
  libgdcm2-dev (>= 2.0.16), libqtwebkit-dev | libqt4-dev (<< 4.7)
Standards-Version: 3.9.1
Homepage: http://gofigure2.sourceforge.net
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/gofigure2/trunk/?rev=0&sc=0
Vcs-Svn: svn://svn.debian.org/svn/debian-med/trunk/packages/gofigure2/trunk/

Package: gofigure2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tool for visualizing, processing and analysing of bioimages
 Main objectives of GoFigure2 are to provide
  * interaction/visualization/navigation into 4D multichannels bio-images;
  * save/retrieve information related to the imaging process, analysis results;
  * extracting objects from bio-images (e.g. nucleii, cell-membranes...);
  * tracking sub-cellular structure, cells;
  * detecting and tracking cell-division through time;
  * generating and visualizing cell-lineage. 

Package: libgofigure0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tool for visualizing, processing and analysing of bioimages
 Main objectives of GoFigure2 are to provide
  * interaction/visualization/navigation into 4D multichannels bio-images;
  * save/retrieve information related to the imaging process, analysis results;
  * extracting objects from bio-images (e.g. nucleii, cell-membranes...);
  * tracking sub-cellular structure, cells;
  * detecting and tracking cell-division through time;
  * generating and visualizing cell-lineage. 
 .
 The runtime libraries

Package: libgofigure-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tool for visualizing, processing and analysing of bioimages
 Main objectives of GoFigure2 are to provide
  * interaction/visualization/navigation into 4D multichannels bio-images;
  * save/retrieve information related to the imaging process, analysis results;
  * extracting objects from bio-images (e.g. nucleii, cell-membranes...);
  * tracking sub-cellular structure, cells;
  * detecting and tracking cell-division through time;
  * generating and visualizing cell-lineage. 
 .
 The development libraries

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh --parallel $@ 

override_dh_auto_configure:
	dh_auto_configure -- -DGOFIGURE2_INSTALL_LIB_DIR:STRING=lib -DCMAKE_BUILD_TYPE:STRING=Release

override_dh_shlibdeps:
	LD_LIBRARY_PATH=debian/gofigure2/usr/lib/gofigure2 dh_shlibdeps -l/usr/lib/gofigure2

get-orig-source:
	uscan --verbose --force-download --repack --rename

## gofigure2 0.8.2

=== debian/changelog ===
gofigure2 (0.8.2-1) unstable; urgency=low

  [ Andreas Tille ]
  * New upstream version
    debian/patches/qreal_getrgb.patch: removed because applied upstream
    debian/patches/apple_bundle_fix.patch: adapted to new version
  * debian/control:
    - Added myself to Uploaders
    - Standards-Version: 3.9.2 (no changes needed)
    - Build-Depends: libfftw3-dev which is needed in new version
  * Debhelper 8 (control+compat)
  * Remove wrongly placed file libgofigure0.lintian-overrides
  * debian/rules: --parallel option needs to be added in the end

  [ Mathieu Malaterre ]
  * Change get-orig-source target to remove testing data
  * Add suggests on mysql-server. Closes: #634921

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Mon, 29 Aug 2011 15:20:21 +0200

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,11 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 DM-Upload-Allowed: yes
 Uploaders: Mathieu Malaterre <mathieu.malaterre@gmail.com>,
-Build-Depends: debhelper (>= 7.0.50~), cmake (>= 2.8.2), libboost-all-dev, libqt4-dev, libinsighttoolkit3-dev (>= 3.20), libvtk5-qt4-dev (>= 5.6),
+ Andreas Tille <tille@debian.org>
+Build-Depends: debhelper (>= 8), cmake (>= 2.8.2), libboost-all-dev, libqt4-dev,
+  libinsighttoolkit3-dev (>= 3.20), libvtk5-qt4-dev (>= 5.6), libfftw3-dev,
   libgdcm2-dev (>= 2.0.16), libqtwebkit-dev | libqt4-dev (<< 4.7)
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Homepage: http://gofigure2.sourceforge.net
 Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/gofigure2/trunk/?rev=0&sc=0
 Vcs-Svn: svn://svn.debian.org/svn/debian-med/trunk/packages/gofigure2/trunk/
@@ -14,6 +16,7 @@
 Package: gofigure2
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Suggests: mysql-server
 Description: Tool for visualizing, processing and analysing of bioimages
  Main objectives of GoFigure2 are to provide
   * interaction/visualization/navigation into 4D multichannels bio-images;
